<div class="row">
    <div class="col-md-2"></div>
    <div class="col-md-8">
        <div class="row">
            <div class="col">
                <div class="alert alert-box" role="alert">
                    <button type="button" class="btn btn-outline-secondary" style="float:left;" (click)="goToBack() ">
                        <span  aria-hidden="true" class="oi oi-chevron-left icon-header mr-30 "></span>
                    </button>
                    <h3>Gestione Dettaglio Rilievo</h3>
                </div>
            </div>
        </div>
        <div class="row">
            <div class="col">
                <app-alert></app-alert>
            </div>
        </div>
    <form #manageEvalFormRef="ngForm" name="myForm"  [ngClass]="{'line-through': model.isDeleted()}">
        <div class="row">
            <div class="col">
                <div class="form-group">
                    <label class=" font-weight-bold">Data Inserimento: </label>
                    <input type="text" class="form-control " [ngModel]="model._insertDate | date: 'dd/MM/yyyy'" name="insertDate" disabled>
                </div>
            </div>
            <div class="col">
                <div class="form-group"
                    [ngClass]="{'has-error' : (competenceDateRef.invalid && (competenceDateRef.dirty || competenceDateRef.touched))}">
                    <label class=" font-weight-bold">Data Competenza: </label>
                    <input type="text" autocomplete="off" class="form-control"
                        [(ngModel)]="model._competenceDate" name="competenceDate" bsDatepicker
                        [bsConfig]="{ dateInputFormat: 'DD/MM/YYYY', containerClass: 'theme-default', showWeekNumbers : false }"
                        [bsValue]="model._competenceDate"   [disabled]="!(model.reason.id == settings.rcReason.id && !model.accountDate)" [maxDate]="competenceDateUpperBound()"  required placeholder="gg/mm/aaaa"
                        #competenceDateRef="ngModel"><!---->
                    <div *ngIf="(competenceDateRef.invalid && (competenceDateRef.dirty || competenceDateRef.touched))"
                        class="validation-messages">
                        <div  *ngIf="competenceDateRef.errors.required; then requiredErr else invalidErr">
                        </div>
                        <ng-template #requiredErr>Campo obbligatorio</ng-template>
                        <ng-template #invalidErr>{{competenceDateRef.errors.error}}</ng-template>
                    </div>
                </div>
            </div>
            <div class="col">
                <div class="form-group">
                    <label class=" font-weight-bold">Nr. Rilievo: </label>
                    <input type="text" autocomplete="off" class="form-control" value="{{model.id}}" name="id" disabled>                 
                </div>
            </div>                    
        </div>


        <hr>
        <div class="row">
            <div class="col">
                <div class="form-group">
                    <label class=" font-weight-bold">Filiale:</label>
                    <div class="form-group">
                        <ng-select
                            [ngClass]="{'has-errorSelect' : (BranchRef.invalid && (BranchRef.dirty || BranchRef.touched))}"
                            [items]="branchOptions" name="branch" style="width: 100%" bindLabel="full"
                            placeholder="Seleziona Filiale" notFoundText="Nessun Risultato"
                            (change)="selectionBranchChanged($event)" [(ngModel)]="model.branch" #BranchRef="ngModel" disabled required>
                        </ng-select>
                        <div *ngIf="BranchRef.errors && (BranchRef.dirty || BranchRef.touched)"
                            class="validation-messagesSelect">
                            <div [hidden]="!BranchRef.errors.required">
                                <div *ngIf="BranchRef.errors.required; then requiredErr else invalidErr"></div>
                                <ng-template #requiredErr>Seleziona una Filiale</ng-template>
                                <ng-template #invalidErr>{{BranchRef.errors.error}}</ng-template>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <div class="col">
                <div class="form-group"
                    [ngClass]="{'has-error' : (frazionarioRef.invalid && (frazionarioRef.dirty || frazionarioRef.touched))}">
                    <label class="font-weight-bold">Frazionario Up: </label>
                    <input type="text" class="form-control " placeholder="Inserisci un Frazionario" name="fractional"
                        (change)="fractionalChanged($event)" [(ngModel)]="model.fractional" required maxlength="20"
                        #frazionarioRef="ngModel"  disabled>
                    <div *ngIf="(frazionarioRef.invalid && (frazionarioRef.dirty || frazionarioRef.touched))"
                        class="validation-messages">
                        <div *ngIf="frazionarioRef.errors.required; then requiredErr else invalidErr"> </div>
                        <ng-template #requiredErr>Campo Obbligatorio</ng-template>
                        <ng-template #invalidErr>Codice Frazionario non valido</ng-template>
                    </div>
                </div>
            </div>
            
            <div class="col">
                
                <div class="form-group">
                    <label class="font-weight-bold">Denominazione Up:</label>
                    <div class="form-group">
                        <ng-select
                            [ngClass]="{'has-errorSelect' : (OfficeRef.invalid && (OfficeRef.dirty || OfficeRef.touched))}"
                            [items]="officeList" name="office" style="width: 100%"
                            disabled
                            bindLabel="fractionalDescription" placeholder="Seleziona Denominazione"
                            notFoundText="Nessun Risultato" (change)="selectionOfficeChanged($event)"
                            [(ngModel)]="model.office" #OfficeRef="ngModel" required>
                        </ng-select>
                        <div *ngIf="OfficeRef.errors && (OfficeRef.dirty || OfficeRef.touched)"
                            class="validation-messagesSelect">    
                            <div [hidden]="!OfficeRef.errors.required">
                                Seleziona un Ufficio
                            </div>
                        </div>
                    </div>
                </div>
            
        </div>
        </div>
        <hr>
        <div class="row">
            <div class="col">
                <div class="form-group">
                    <label class="font-weight-bold">Voce
                        Daco: </label>
                    <div class="form-group">
                        <ng-select
                            [ngClass]="{'has-errorSelect' : (dacoRef.invalid && (dacoRef.dirty || dacoRef.touched))}"
                            [items]="dacoList" name="daco" style="width: 100%"
                            (change)="selectionDacoChanged($event, model)" bindLabel="full"
                            placeholder="Seleziona Daco" [disabled]="!(model.reason.id == settings.rcReason.id && !model.accountDate)" notFoundText="Nessun Risultato" [(ngModel)]="model.daco"
                            #dacoRef="ngModel" required>
                        </ng-select>
                        <div *ngIf="dacoRef.errors && (dacoRef.dirty || dacoRef.touched)"
                            class="validation-messagesSelect">
                            <div *ngIf="dacoRef.errors.required; then requiredErr else invalidErr"></div>
                            <ng-template #requiredErr> Seleziona una voce Daco</ng-template>
                            <ng-template #invalidErr>{{dacoRef.errors.error}}</ng-template>
                        </div>
                    </div>
                </div>
            </div>
            <div class="col">
                <div class="form-group">
                    <label class="font-weight-bold">Servizio: </label>
                    <div class="input-group form-group ">
                        <ng-select [items]="model.daco?.services" name="service" style="width: 100%" bindLabel="full"
                            placeholder="Seleziona Servizio" [disabled]="model.daco == null || model.daco.services?.length==0"
                            notFoundText="Nessun Risultato" [(ngModel)]="model.service" #serviceRef="ngModel" required>
                        </ng-select>
                        <div *ngIf="(serviceRef.invalid && (serviceRef.dirty || serviceRef.touched))" class="validation-messagesSelect">
                            <div *ngIf="serviceRef.errors.required; then requiredErr else invalidErr"> </div>
                             <ng-template #requiredErr>Campo Obbligatorio</ng-template>
                             <ng-template #invalidErr>{{serviceRef.errors.error}}</ng-template>
                        </div>
                    </div>
                </div>
            </div>
                <div class="col">
                    <!--div class="form-group"
                        [ngClass]="{'has-error' : (codContabileRef.invalid && (codContabileRef.dirty || codContabileRef.touched))}">
                        <label class="font-weight-bold">Cocont: </label>
                        <input type="text" class="form-control " name="accountNumber" (change)="accountNumberChanged(dacoList, model,'accountNumber');"
                            placeholder="" [(ngModel)]="model.daco.accountNumberFull" required disabled
                            maxlength="20" #codContabileRef="ngModel">
                        <div *ngIf="(codContabileRef.invalid && (codContabileRef.dirty || codContabileRef.touched))"
                            class="validation-messages">
                            <div *ngIf="codContabileRef.errors.required; then requiredErr else invalidErr"> </div>
                            <ng-template #requiredErr>Campo Obbligatorio</ng-template>
                            <ng-template #invalidErr>Codice Contabile non valido</ng-template>
                        </div>
                    </div-->
                </div>
                
        </div>
        <hr>
        <div class="row">
                <div class="col">
                    <div class="form-group">
                        <label class="font-weight-bold">Causale Rilievo:</label>
                        <div class="form-group">
                            <input type="text" name="reason" style="width: 100%" class="form-control "
                                [ngModel]="model?.reason?.full"
                                #reasonRef="ngModel" disabled>                                     
                        </div>
                    </div>
                </div>
                <div class="col">
                    <div class="form-group">
                            <label class="font-weight-bold">Connotazione a Perdita: </label>
                            <div class="input-group form-group ">
                                <input type="text" name="status" style="width: 100%" disabled class="form-control "
                                     [ngModel]="model.status?.code!=788?model.status?.description: '' " #statusRef="ngModel">
                               
                            </div>                     
                    </div>
                </div>

                
                <div class="col">
                        <div class="form-group" *ngIf="model.idParent || model.idChild">
                                <label class="font-weight-bold" ><div *ngIf="model.idParent != null; then LabelParent else  LabelChild"></div></label>
                                <ng-template #LabelParent>Nr. Rilievo Origine</ng-template>
                                <ng-template #LabelChild>Nr. Rilievo Generato</ng-template>
                                <div class="input-group form-group ">
                                        <input type="text" class="form-control "  name="generated"
                                       value="{{model.idParent ? model.idParent : model.idChild}}" maxlength="20"
                                        disabled>                            
                                </div>    
                        </div>
                </div>
        </div>
        <hr>
        <div class="row">
            <div class="col">
                <label class="font-weight-bold textSize">{{labelCredit}}                      
                </label>
            </div>
            <div class="col">
                <label class="font-weight-bold textSize">{{labelDebit}}   
                    </label>
            </div>
            <div class="col">

            </div>
        </div>
        <div class="row">
            <div class="col">
                <div class="row">
                    <div class="col">
                        <div class="form-group"
                            [ngClass]="{'has-error' : (creditAmountRef.invalid && (creditAmountRef.dirty || creditAmountRef.touched))}">
                            <div class="input-group">
                                <div class="input-group-prepend">
                                    <div class="input-group-text"><strong>€</strong></div>
                                </div>
                                <input type="text" autocomplete="off" class="form-control "
                                    [(ngModel)]="model.creditAmount" name="creditAmount"
                                    placeholder="Inserisci un importo" (keypress)="cleanAmount(true)"
                                    (keydown)="checkAmountDigit($event)" pattern="^[0-9]{1,}([.][0-9]{1,2})?$"
                                    min="0" (change)="cleanAmount(true); checkValidAmount(false);"
                                    onPaste="cleanAmount(true)" #creditAmountRef="ngModel"  [disabled]="!(model.reason.id == settings.rcReason.id && !model.accountDate)" maxlength="14">
                                <!--Campo da switchare per la validazione-->
                            </div>
                            <div *ngIf="(creditAmountRef.invalid && (creditAmountRef.dirty || creditAmountRef.touched))"
                                class="validation-messages">
                                <div *ngIf="creditAmountRef.errors.required; then requiredErr else invalidErr"> </div>
                                     <ng-template #requiredErr>Campo obbligatorio e di tipo numerico</ng-template>
                                     <ng-template #invalidErr>{{creditAmountRef.errors.error}}</ng-template>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <div class="col">
                <div class="row">
                    <div class="col">
                        <div class="form-group"
                            [ngClass]="{'has-error' : (debitAmountRef.invalid && (debitAmountRef.dirty || debitAmountRef.touched))}">
                            <div class="input-group">
                                <div class="input-group-prepend">
                                    <div class="input-group-text"><strong>€</strong></div>
                                </div>
                                <input maxlength="14" type="text" autocomplete="off" class="form-control "
                                    [(ngModel)]="model.debitAmount" name="debitAmount"
                                    placeholder="Inserisci un importo" pattern="^[0-9]{1,}([.][0-9]{1,2})?$" min="0"
                                    (keypress)="cleanAmount()" (keydown)="checkAmountDigit($event)"
                                    (change)="cleanAmount();  checkValidAmount(true);"    [disabled]="!(model.reason.id == settings.rcReason.id && !model.accountDate)" onPaste="cleanAmount();"
                                    #debitAmountRef="ngModel" >
                                <!--  Campo da switchare per la validazione-->
                            </div>
                            <div *ngIf="(debitAmountRef.invalid && (debitAmountRef.dirty || debitAmountRef.touched))"
                                class="validation-messages">
                                <div *ngIf="debitAmountRef.errors.required; then requiredErr else invalidErr"> </div>
                                <ng-template #requiredErr>Campo obbligatorio e di tipo numerico</ng-template>
                                <ng-template #invalidErr>{{debitAmountRef.errors.error}}</ng-template>
                            </div>
                        
                        </div>
                    </div>
                </div>
            </div>
            <div class="col">
                <div class="form-group ">
                        <button type="button" class="btn btn-primary btn-sm" style="margin-right: 16px;"
                        (click)="openAttachmentsModal(AttachmentComponet)" [disabled]="model.isDeleted()" >Allegati
                        ({{totalAttachments}})</button>

                        <button type="button" class="btn btn-primary btn-sm"  style="margin-right: 16px;"
                        (click)="openNoteModal(ManageNote)" [disabled]="model.isDeleted()">Note
                        ({{totalNotes}})</button>
                </div>
            </div>
        </div>
        <hr>
        <div class="row">
            <div class="col">
                <div class="form-group">
                    <label class=" font-weight-bold">Data Contabilizzazione: </label>
                    <input type="text" class="form-control " [ngModel]="model.accountDate | date: 'dd/MM/yyyy'" name="accountDate" disabled>
                </div>
            </div>
            <div class="col">
                <div class="form-group">
                    <label class=" font-weight-bold">Data Regolarizzazione: </label>
                    <input type="text" autocomplete="off" class="form-control" [ngModel]="model.regularizationDate | date: 'dd/MM/yyyy'" name="regularizationDate" disabled #regularizationDateRef="ngModel">                 
                </div>
            </div>
            <div class="col">
                <div class="form-group">
                                  
                </div>
            </div>                    
        </div>
        <div class="row">
                <div class="col">
                    <div class="form-group">
                        <label class="font-weight-bold">Descrizione: </label>
                        <textarea class="form-control  form-control-sm" placeholder="Inserisci una descrizione"
                            [(ngModel)]="model.description" maxlength="600" name="description" id="description" rows="3"
                            [disabled]="!(model.reason.id == settings.rcReason.id && model.creditAmount>0 && model.accountDate != null && model.regularizationDate == null)&& !(model.reason.id == settings.rcReason.id && model.accountDate == null)"
                            ngModel></textarea>
                    </div>
                </div>
        </div>
        <hr>
        <div class="row">
            <div class="col">
            <button type="button" *ngIf="isUndoEnabled()" class="btn btn-sm btn-primary size" style="float: left; margin-right: 16px;"
                (click)="btnDeleteEval()" [disabled]="(model.isDeleted() || model.accountDate!= null || model.idChild != null )" ngmodel>Annulla Rilievo</button>
                
            <button *ngIf="isSetLossEnabled()" type="button" class="btn btn-sm btn-primary size" style="float: left; margin-right: 16px; "
                (click)="setLossState(SelectStatus)" [disabled]="(model.isDeleted() || !( model.reason.id == settings.rcReason.id && model.creditAmount>0 && model.accountDate != null && model.regularizationDate == null && model.status.id == settings.unLossState.id))">
                Connotazione a Perdita</button>

            <button *ngIf="isSetLossEnabled() && model.status.id != settings.unLossState.id" type="button" class="btn btn-sm btn-primary size" style="float: left; margin-right: 16px; display: block;" 
                   (click)="undoLossState()" [disabled]="(model.isDeleted() || !(model.reason.id == settings.rcReason.id && model.creditAmount>0 && model.accountDate != null && model.regularizationDate == null && model.status.id != settings.unLossState.id))">Annullo Connotazione</button>
                
            <button *ngIf="(isChangeReasonEnabled()) && (model.reason.id != settings.rcReason.id || (model.reason.id == settings.rdReason.id || model.reason.id == settings.rsReason.id))" type="button" class="btn btn-sm btn-primary size" style="float: left; margin-right: 16px; "
                   (click)="reasonToRc()" [disabled]="(model.isDeleted() || !(model.regularizationDate == null && (model.reason.id == settings.rdReason.id || model.reason.id == settings.rsReason.id)))">Trasformazione da RS-RD a RC</button>
                
            <button *ngIf="(isChangeReasonEnabled()) && (model.reason.id == settings.rcReason.id)" type="button" class="btn btn-sm btn-primary size" style="float: left; margin-right: 16px;"
                   (click)="reasonToRsRd()" [disabled]="(model.isDeleted() || !(model.accountDate == null && (model.reason.id == settings.rcReason.id) && model.previousReason != null))">Annullo Trasformazione</button>
                
            <button *ngIf="isChangeFractionalEnabled()" type="button" name="btnUpdFractional" class="btn btn-sm btn-primary size" style="float: left; margin-right: 16px;"
                (click)="updateFranctional()" [disabled]="(model.isDeleted() || !(model.reason.id == settings.rcReason.id && model.accountDate==null ) || !manageEvalFormRef.controls['fractional']?.disabled )">Modifica Frazionario</button>                  

            <button type="button" [disabled]="(model.isDeleted() || (manageEvalFormRef.pristine && manageEvalFormRef.controls['fractional']?.disabled ))" class="btn btn-sm btn-danger size buttonCancel" (click)="btnAnnulla()"
                 >Annulla</button>

            <button name="saveChange" type="button" [disabled]="(model.isDeleted() || !(manageEvalFormRef.valid) || manageEvalFormRef.pristine)"
                    (click)="saveChange()" class="btn btn-sm btn-success size buttonConfirm">Conferma</button>
        </div>
    </div>
        </form> 
    </div>
    <div class="col-md-2"></div>
</div>
<hr>
<ng-template #AttachmentComponet>
        <app-attachment [evaluation-id]="model.id"  [modalRef]="modalRef" (numberAttachmentsChanged)="updateTotalAttachments($event)" ></app-attachment>
</ng-template>
<ng-template #SelectStatus>
        <app-modal-select-status [evaluation-id]="model.id" [selectedStatus]="model.status" [statusList]="statusList" [modalRef]="modalRef" (statusChanged)="updateLossState($event)" ></app-modal-select-status>
</ng-template>
<ng-template #ManageNote>
        <app-note [evaluation-id]="model.id" [modalRef]="modalRef" (numberNotesChanged)="updateTotalNotes($event)" ></app-note>
</ng-template>
